-- Add electric-tree which is a treeified electric pole

local function has_value(tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end
    return false
end

local props = {
    'emissions_per_second',
    'autoplace',
    -- 'collision_box'
}
local electric_trees = {}
local dont_place = {'wreck-pole'}



local i = 1
for k, pole in pairs(data.raw['electric-pole']) do
    if pole.name ~= "wreck-pole" and string.find(pole.name, 'creative') == nil then -- invisible in Factorio 0.17.32
        local electric_tree = table.deepcopy(pole)
        -- if pole.name == "wreck-pole" then
        --     local substation = table.deepcopy(data.raw['electric-pole']['substation'])
        --     electric_tree.pictures = substation.pictures
        --     electric_tree.pictures.layers[1].filename = "__base__/graphics/entity/escape-pod-power/escape-pod-power.png"
        --     for k, v in pairs(electric_tree.pictures.layers) do
        --         v.direction_count = 1
        --     end
        --     electric_tree.pictures.layers[1].width = 210
        --     electric_tree.pictures.layers[1].height = 144
        --     electric_tree.pictures.layers[1].hr_version.filename = "__base__/graphics/entity/escape-pod-power/hr-escape-pod-power.png"
        --     electric_tree.pictures.layers[1].hr_version.width = 416
        --     electric_tree.pictures.layers[1].hr_version.height = 286
        --     for k, v in pairs(electric_tree.pictures.layers) do
        --         if v.hr_version then v.hr_version.direction_count = 1 end
        --     end
        -- end
        electric_tree.name = string.gsub(pole.name, 'pole', 'tree')
        if electric_tree.name == pole.name then electric_tree.name = electric_tree.name .. '-tree' end
        if data.raw.tree['tree-0'..i] == nil then i = 1 end
        local tree = table.deepcopy(data.raw.tree['tree-0'..i])
        for j, prop in pairs(props) do
            electric_tree[prop] = tree[prop]
        end
        electric_tree.autoplace.force = 'player'
        electric_tree.order = electric_tree.name
        electric_tree.autoplace.max_probability = math.min(1, (7.5*2)/math.pow(electric_tree.maximum_wire_distance*electric_tree.supply_area_distance, 1.5))
        table.insert(electric_trees, electric_tree)
        i = i + 1
    end
end

for i, tree in pairs(data.raw.tree) do
    if string.find(tree.name, 'dead') == nil then data.raw.tree[i] = nil end
end

data:extend(electric_trees)

-- -- Electric-pole-ify the trees!
-- local props = {'connection_points', 'connection_points', 'minable', 'radius_visualisation_picture', 'supply_area_distance', 'type'}
-- for i, tree in pairs(data.raw.tree) do
--     -- data.raw.tree[i] = data.raw["electric-pole"]["small-electric-pole"]
--     local small_pole = table.deepcopy(data.raw["electric-pole"]["small-electric-pole"])
--     for j, prop in pairs(props) do
--         tree[prop] = small_pole[prop]
--     end
--     -- table.remove(data.raw.tree, i)
--     data.raw.tree[i] = nil
--     data:extend({tree})
-- end
